<?php

namespace Pinpoint\PackingSlips\Controller\Adminhtml\Generate;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;

/**
 * Class Index
 * @package Pinpoint\PackingSlips\Controller\Adminhtml\Generate
 */
class Index extends Action
{
    /**
     * @var \Pinpoint\PackingSlips\Model\Pdf\GenerateSlip
     */
    protected $pickingSlip;

    /**
     * Index constructor.
     * @param Context $context
     * @param \Pinpoint\PackingSlips\Model\Pdf\GenerateSlip $pickingSlip
     */
    public function __construct(
        Context $context,
        \Pinpoint\PackingSlips\Model\Pdf\GenerateSlip $pickingSlip
    ) {
        $this->pickingSlip = $pickingSlip;

        parent::__construct($context);
    }

    /**
     * Check the permission to run it
     *
     * @return boolean
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('');
    }

    public function execute()
    {
        $orderId = $this->getRequest()->getParam('id');
        $packingSlip = $this->pickingSlip->generateSlip($orderId);

        $packingSlip->stream("packing-slip-{$orderId}.pdf", ['Attachment' => true]);
        exit(0);
    }
}
